execute as @e[tag=Boss,scores={TimeBoss=0}] run scoreboard players add @s Time 1
scoreboard players set @e[tag=Boss,scores={TimeBoss=1}] Time 0

execute at @e[tag=Boss,scores={Time=3}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Offense\""}
execute at @e[tag=Boss,scores={Time=3}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Defense\""}
execute at @e[tag=Boss,scores={Time=3}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Vex\""}
execute at @e[tag=Boss,scores={Time=3}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Shadow\""}
execute at @e[tag=Boss,scores={Time=3}] run tag @e[type=area_effect_cloud,limit=1,sort=random,distance=..1] add Choose

execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run tag @s add HitDone
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run tag @s add EnemyNoMove
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run scoreboard players set @s Time 8

execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Offense,tag=Choose,distance=..1] run tag @s add Offense
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Offense,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 6
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Defense,tag=Choose,distance=..1] run tag @s add Defense
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Defense,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 4
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Vex,tag=Choose,distance=..1] run tag @s add Vex
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Vex,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 3
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Shadow,tag=Choose,distance=..1] run tag @s add Shadow
execute as @e[tag=Boss,scores={Time=3..}] at @s if entity @e[name=Shadow,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 3

scoreboard players remove @e[tag=Boss,scores={TimeBoss=1..}] TimeBoss 1
execute as @e[tag=Boss,scores={TimeBoss=1..}] run tag @s add HitDone
execute as @e[tag=Boss,scores={TimeBoss=1..}] run tag @s add EnemyNoMove

execute as @e[tag=Boss,scores={TimeBoss=5},tag=Offense] run tellraw @a[tag=Playing] {"text":"Darkfang attacks...","color":"dark_green"}
execute as @e[tag=Boss,scores={TimeBoss=5},tag=Offense] at @e[tag=BossRoom] run tp @s ~ 8 ~
execute as @e[tag=Boss,scores={TimeBoss=5},tag=Offense] at @s run particle dragon_breath ~ ~ ~ 0.2 0.2 0.2 0.1 100 force
execute as @e[tag=Boss,scores={TimeBoss=5},tag=Offense] run summon area_effect_cloud ~ 8 ~ {CustomName:"\"EvokerBeam\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=5},tag=Offense] at @s run tp @e[name=EvokerBeam] ~ 8 ~ facing entity @e[tag=Player,limit=1]
execute as @e[tag=Boss,scores={TimeBoss=4},tag=Offense] as @e[name=EvokerBeam] at @s run function enemy:boss/evokerbeam
execute as @e[tag=Boss,scores={TimeBoss=4},tag=Offense] run summon area_effect_cloud ~ 8 ~ {CustomName:"\"EvokerBeam\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=4},tag=Offense] at @s run tp @e[name=EvokerBeam] ~ 8 ~ facing entity @e[tag=Player,limit=1]
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Offense] as @e[name=EvokerBeam] at @s run function enemy:boss/evokerbeam
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Offense] run summon area_effect_cloud ~ 8 ~ {CustomName:"\"EvokerBeam\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Offense] at @s run tp @e[name=EvokerBeam] ~ 8 ~ facing entity @e[tag=Player,limit=1]
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Offense] as @e[name=EvokerBeam] at @s run function enemy:boss/evokerbeam
tag @e[tag=Boss,scores={TimeBoss=0},tag=Offense] remove Offense

execute as @e[tag=Boss,scores={TimeBoss=3},tag=Defense] run tellraw @a[tag=Playing] {"text":"Darkfang defends...","color":"dark_green"}
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~1 ~-0.25 ~
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~-1 ~-0.25 ~
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~ ~-0.25 ~1
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~ ~-0.25 ~-1
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~1 ~-0.25 ~1
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~1 ~-0.25 ~-1
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~-1 ~-0.25 ~1
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run summon evoker_fangs ~-1 ~-0.25 ~-1
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @s run particle witch ~ ~ ~ 0.3 0.5 0.3 0.1 100 force
execute as @e[tag=Boss,scores={TimeBoss=1..2},tag=Defense] at @e[type=evoker_fangs] positioned ~ ~-0.5 ~ run scoreboard players remove @e[tag=Player,distance=..1] Health 30
tag @e[tag=Boss,scores={TimeBoss=0},tag=Defense] remove Defense

execute as @e[tag=Boss,scores={TimeBoss=2},tag=Vex] run tellraw @a[tag=Playing] {"text":"Darkfang summons...","color":"dark_green"}
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Vex] at @s run summon area_effect_cloud ~ ~ ~ {CustomName:"\"TeleportBoss\""}
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Vex] at @e[name=BossStand,limit=1] run spreadplayers ~ ~ 1 3 true @e[name=TeleportBoss,type=area_effect_cloud]
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Vex] as @e[name=TeleportBoss,type=area_effect_cloud] at @s run tp @s ~ 8 ~
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Vex] at @e[name=TeleportBoss,type=area_effect_cloud] run tp @s ~ ~ ~
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Vex] at @s run particle dragon_breath ~ ~ ~ 0.2 0.2 0.2 0.1 100 force
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] at @s run summon area_effect_cloud ~ ~ ~ {CustomName:"\"SummonVex\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] at @s run summon area_effect_cloud ~ ~ ~ {CustomName:"\"SummonVex\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] at @s run summon area_effect_cloud ~ ~ ~ {CustomName:"\"SummonVex\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] at @e[name=Room,tag=BossRoom] run spreadplayers ~ ~ 1 3 false @e[name=SummonVex,type=area_effect_cloud]
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] as @e[name=SummonVex,type=area_effect_cloud] at @s run tp @s ~ 8 ~
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] at @e[name=SummonVex,type=area_effect_cloud] run particle smoke ~ ~ ~ 0.4 0.4 0.4 0.01 100 force
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] at @e[name=SummonVex,type=area_effect_cloud] if block ~ ~ ~ #path:standable run summon vex ~ ~ ~ {NoAI:1,Tags:["Enemy","EnemyNoMove","HitDone"]}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] run scoreboard players set @e[type=vex,tag=!Secured] AttackMin 8
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] run scoreboard players set @e[type=vex,tag=!Secured] AttackMax 10
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] run scoreboard players set @e[type=vex,tag=!Secured] DefenseMin 0
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] run scoreboard players set @e[type=vex,tag=!Secured] DefenseMax 0
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] run scoreboard players set @e[type=vex,tag=!Secured] Health 1
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] as @e[type=vex,tag=!Secured] at @s run tp @s ~ ~ ~ facing entity @e[tag=Player,limit=1]
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] run tag @e[type=vex,tag=!Secured] add Secured
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Vex] as @e[name=SummonVex,type=area_effect_cloud] run kill @s
tag @e[tag=Boss,scores={TimeBoss=0},tag=Vex] remove Vex

execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run tellraw @a[tag=Playing] {"text":"Darkfang hides...","color":"dark_green"}
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] at @s run summon vex ~ ~ ~ {NoAI:1,Tags:["Enemy","EnemyNoMove","HitDone"]}
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run scoreboard players set @e[type=vex,tag=!Secured] AttackMin 8
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run scoreboard players set @e[type=vex,tag=!Secured] AttackMax 10
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run scoreboard players set @e[type=vex,tag=!Secured] DefenseMin 0
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run scoreboard players set @e[type=vex,tag=!Secured] DefenseMax 0
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run scoreboard players set @e[type=vex,tag=!Secured] Health 25
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run tag @e[type=vex,tag=!Secured] add Secured
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] run tag @s add Invisible
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] at @s run particle dragon_breath ~ ~ ~ 0.2 0.2 0.2 0.01 100 force
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] at @s run summon area_effect_cloud ~ ~ ~ {CustomName:"\"TeleportBoss\""}
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] at @e[name=BossStand,limit=1] run spreadplayers ~ ~ 1 3 true @e[name=TeleportBoss,type=area_effect_cloud]
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] as @e[name=TeleportBoss,type=area_effect_cloud] at @s run tp @s ~ 8 ~
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Shadow] at @e[name=TeleportBoss,type=area_effect_cloud] run tp @s ~ ~ ~
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Shadow] at @s run particle dragon_breath ~ ~ ~ 0.2 0.2 0.2 0.01 100 force
tag @e[tag=Boss,scores={TimeBoss=0},tag=Shadow] remove Shadow

execute at @e[name=FangPlace] run summon evoker_fangs ~ ~-0.25 ~
execute at @e[name=FangPlace] positioned ~ ~-0.5 ~ run scoreboard players remove @e[tag=Player,distance=..1] Health 40
execute as @e[name=FangPlace] run kill @s
execute as @e[tag=Player] at @s if block ~ ~-1 ~ obsidian run summon area_effect_cloud ~ ~ ~ {CustomName:"\"FangPlace\"",Duration:200000}

execute as @e[tag=Boss,scores={Time=3..,TimeBoss=0}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run scoreboard players set @s Time 0
execute as @e[tag=Boss,scores={Time=3..}] run kill @e[type=area_effect_cloud,distance=..1]