fill 65 10 0 92 14 -34 black_concrete
fill 68 8 -7 68 9 -7 black_stained_glass
fill 68 8 -14 68 9 -14 black_stained_glass
fill 72 8 -18 72 9 -16 black_stained_glass
fill 74 8 -21 76 9 -21 black_stained_glass
fill 74 8 -28 76 9 -28 black_stained_glass
fill 89 8 -6 89 9 -6 air
fill 65 10 0 71 14 -6 barrier
fill 84 7 -26 80 15 -22 redstone_block replace red_concrete
fill 87 7 -1 91 15 -5 slime_block replace lime_concrete
summon blaze 68 8 -3 {Tags:["Player"],NoAI:1,PersistenceRequired:1}
execute at @e[tag=Player] run tp @e[type=armor_stand,name=Start] ~ 8 ~
tp @a[tag=Playing] 68 15 -3
tag @a[tag=Playing] remove Lobby

scoreboard players set @e[tag=Player] Health 100
scoreboard players set @e[tag=Player] HealthMax 100
scoreboard players set @e[tag=Player] Magic 50
scoreboard players set @e[tag=Player] MagicMax 50
scoreboard players set @e[tag=Player] Experience 0
scoreboard players set @e[tag=Player] ExperienceLevel 1
scoreboard players set @e[tag=Player] ExperienceMax 100
scoreboard players set @e[tag=Player] AttackMin 5
scoreboard players set @e[tag=Player] AttackMax 8
scoreboard players set @e[tag=Player] DefenseMin 0
scoreboard players set @e[tag=Player] DefenseMax 3
scoreboard players set @e[tag=Player] Honor 0
scoreboard players set Orb Math 0
scoreboard players set Food ListBuff 250
scoreboard players set DefenseArmor1X Math 0
scoreboard players set DefenseArmor2X Math 0
scoreboard players set DefenseArmor3X Math 0
scoreboard players set DefenseArmor4X Math 0
scoreboard players reset AttackWeaponX Math
scoreboard players set AttackWeaponY Math 0
scoreboard players set AttackWeapon Math 1
execute store result score DefenseMin Math run scoreboard players get @e[tag=Player,limit=1] DefenseMin
execute store result score DefenseMax Math run scoreboard players get @e[tag=Player,limit=1] DefenseMax
execute store result score AttackMin Math run scoreboard players get @e[tag=Player,limit=1] AttackMin
execute store result score AttackMax Math run scoreboard players get @e[tag=Player,limit=1] AttackMax
scoreboard players set CurrentFloor Math 1
scoreboard players set CurrentFloor MathCurrent 0

kill @e[type=armor_stand,name=Room]
summon armor_stand 68 4 -3 {CustomName:"\"Room\"",NoGravity:1,Marker:1,Tags:["Discovered","Open"]}
summon armor_stand 68 4 -10 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 68 4 -17 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 68 4 -24 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 68 4 -31 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 75 4 -3 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 75 4 -10 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 75 4 -17 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 75 4 -24 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 75 4 -31 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 82 4 -3 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 82 4 -10 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 82 4 -17 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 82 4 -24 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 82 4 -31 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 89 4 -3 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 89 4 -10 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 89 4 -17 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 89 4 -24 {CustomName:"\"Room\"",NoGravity:1,Marker:1}
summon armor_stand 89 4 -31 {CustomName:"\"Room\"",NoGravity:1,Marker:1}

kill @e[name=Dummy,type=armor_stand]
kill @e[tag=Enemy]
kill @e[tag=Shopkeeper]
clear @a[tag=Playing]
tag @a[tag=Playing] add Tutorial
tag @a remove STOP
scoreboard players set TutorialTime Time 0

function main:tutorial/randomizepotion
function main:tutorial/randomizespell
function main:tutorial/randomizescroll
fill 11 4 -16 15 4 -7 minecraft:air
execute at @e[name=Room] if block ~ 7 ~ white_terracotta run summon armor_stand ~ 8 ~ {Tags:["RoomSpecial"],CustomName:"\"CraftRoom\"",Invisible:1}
execute at @e[name=Room] if block ~ 7 ~ orange_terracotta run summon armor_stand ~ 8 ~ {Tags:["RoomSpecial"],CustomName:"\"SmiteRoom\"",Invisible:1}
execute at @e[name=Room] if block ~ 7 ~ light_blue_terracotta run summon armor_stand ~ 8 ~ {Tags:["RoomSpecial"],CustomName:"\"BrewingRoom\"",Invisible:1}
execute at @e[name=Room] if block ~ 7 ~ light_gray_terracotta run summon armor_stand ~ 8 ~ {Tags:["RoomSpecial"],CustomName:"\"EndRoom\"",Invisible:1}
execute at @e[name=Room] if block ~ 7 ~ cyan_terracotta run summon armor_stand ~ 8 ~ {Tags:["RoomSpecial"],CustomName:"\"MineRoom\"",Invisible:1}
execute at @e[name=Room] if block ~ 7 ~ cyan_terracotta run setblock ~ 8 ~ chest
execute at @e[name=Room] if block ~ 7 ~ cyan_terracotta run data merge block ~ 8 ~ {LootTable:"loot:mine"}
summon villager 82 8 -31 {CustomName:"\"Shopkeeper\"",NoAI:1,Tags:["ShopKeep","Shopkeeper"]}
setblock 89 8 -24 beacon
setblock 89 7 -24 green_terracotta
setblock 89 7 -10 obsidian

tag @e[tag=Tut_1] remove Tut_1
tag @e[tag=Tut_2] remove Tut_2
tag @e[tag=Tut_3] remove Tut_3
tag @e[tag=Tut_4] remove Tut_4
tag @e[tag=Tut_5] remove Tut_5
tag @e[tag=Tut_6] remove Tut_6
tag @e[tag=Tut_7] remove Tut_7
tag @e[tag=Tut_8] remove Tut_8
tag @e[tag=Tut_9] remove Tut_9
tag @e[tag=Tut_10] remove Tut_10
tag @e[tag=Tut_11] remove Tut_11
tag @e[tag=Tut_12] remove Tut_12
tag @e[tag=Tut_13] remove Tut_13
tag @e[tag=Tut_14] remove Tut_14
tag @e[tag=Tut_15] remove Tut_15

scoreboard players set @a TriggerTut 0
scoreboard players set Tutorial Talk 0
tag @a remove CutScene
tag @a remove Tutorial1
tag @a remove Tutorial2
tag @a remove Tutorial3
tag @a remove Tutorial4
tag @a remove Tutorial5
bossbar set minecraft:health visible false
bossbar set minecraft:experience visible false
bossbar set minecraft:magic visible false
scoreboard objectives setdisplay sidebar