execute as @e[name=Room,type=armor_stand] at @s run function xcity:layout2

execute as @e[name=Room] at @s if block ~2 ~3 ~2 obsidian run tag @s add RoomBig
execute as @e[name=Room] at @s if block ~2 ~3 ~2 air run tag @s add RoomSmall
execute as @e[tag=RoomSmall] at @s if block ~3 ~3 ~ obsidian run scoreboard players add @s Count 1
execute as @e[tag=RoomSmall] at @s if block ~-3 ~3 ~ obsidian run scoreboard players add @s Count 1
execute as @e[tag=RoomSmall] at @s if block ~ ~3 ~3 obsidian run scoreboard players add @s Count 1
execute as @e[tag=RoomSmall] at @s if block ~ ~3 ~-3 obsidian run scoreboard players add @s Count 1

function xcity:balance1

execute at @e[tag=RoomSmall,scores={Count=1}] run fill ~-1 7 ~-1 ~1 7 ~1 obsidian
execute at @e[tag=RoomSmall,scores={Count=2..}] run fill ~-2 7 ~-2 ~2 7 ~2 obsidian

#Set up the start/boss rooms.
execute at @e[name=Room,limit=1,sort=random] run tag @e[type=armor_stand,name=Room,limit=1,sort=furthest,tag=RoomSmall,scores={Count=1}] add StartRoom
execute at @e[tag=StartRoom] run fill ~-2 ~3 ~-2 ~2 ~3 ~2 stone
execute as @e[tag=StartRoom] run tag @s remove RoomSmall
execute at @e[tag=StartRoom] run tag @e[type=armor_stand,name=Room,limit=1,sort=furthest,tag=RoomSmall,scores={Count=1}] add BossRoom
execute at @e[tag=BossRoom] run fill ~-3 ~3 ~-3 ~3 ~3 ~3 bedrock
execute as @e[tag=BossRoom] run tag @s remove RoomSmall

#Making sure that the rooms next to start/boss aren't big rooms.
execute at @e[tag=StartRoom] run scoreboard players set @e[name=Room,distance=..8,tag=!StartRoom,tag=RoomBig] Count 2
execute at @e[tag=StartRoom] run tag @e[name=Room,distance=..8] remove RoomBig
execute at @e[tag=StartRoom] run tag @e[name=Room,distance=..8] add RoomSmall
execute at @e[tag=BossRoom] run scoreboard players set @e[name=Room,distance=..8,tag=!BossRoom,tag=RoomBig] Count 2
execute at @e[tag=BossRoom] run tag @e[name=Room,distance=..15] remove RoomBig
execute at @e[tag=BossRoom] run tag @e[name=Room,distance=..15] add RoomSmall
execute at @e[name=Room,tag=BossRoom] if block ~4 7 ~ obsidian positioned ~7 ~ ~ run tag @e[name=Room,distance=..2] add FinalRoom
execute at @e[name=Room,tag=BossRoom] if block ~-4 7 ~ obsidian positioned ~-7 ~ ~ run tag @e[name=Room,distance=..2] add FinalRoom
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~4 obsidian positioned ~ ~ ~7 run tag @e[name=Room,distance=..2] add FinalRoom
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~-4 obsidian positioned ~ ~ ~-7 run tag @e[name=Room,distance=..2] add FinalRoom
execute at @e[name=Room,tag=BossRoom] at @e[name=Room,distance=..8,tag=!BossRoom,tag=!FinalRoom] run fill ~-4 7 ~-4 ~4 7 ~4 air replace obsidian
execute at @e[name=Room,tag=BossRoom] run kill @e[name=Room,distance=..8,tag=!BossRoom,tag=!FinalRoom]

#Place bigger paths between small rooms.
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~7 ~ ~ if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~3 7 ~1 ~4 7 ~-1 obsidian
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~-7 ~ ~ if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~-3 7 ~1 ~-4 7 ~-1 obsidian
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~ ~ ~7 if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~1 7 ~3 ~-1 7 ~4 obsidian
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~ ~ ~-7 if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~1 7 ~-3 ~-1 7 ~-4 obsidian
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~7 ~ ~ if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~3 8 ~1 ~4 9 ~-1 structure_void
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~-7 ~ ~ if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~-3 8 ~1 ~-4 9 ~-1 structure_void
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~ ~ ~7 if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~1 8 ~3 ~-1 9 ~4 structure_void
execute as @e[tag=RoomSmall,scores={Count=2..}] at @s positioned ~ ~ ~-7 if entity @e[tag=RoomSmall,distance=..2,scores={Count=2..}] at @s run fill ~1 8 ~-3 ~-1 9 ~-4 structure_void

#Marker blocks for debugging.
execute at @e[tag=RoomBig] run setblock ~ ~4 ~ diamond_block
execute at @e[tag=RoomSmall,scores={Count=2..}] run setblock ~ ~4 ~ gold_block
execute at @e[tag=RoomSmall,scores={Count=1}] run setblock ~ ~4 ~ emerald_block