execute as @e[tag=Boss,scores={TimeBoss=0}] run scoreboard players add @s Time 1
scoreboard players set @e[tag=Boss,scores={TimeBoss=1}] Time 0
execute as @e[tag=Boss] unless entity @e[name=Generator,type=armor_stand] run scoreboard players add @s GeneratorTime 1
execute at @e[tag=Boss] if block ~ ~-1 ~ magma_block run setblock ~ ~-1 ~ netherrack
execute at @e[name=Generator] run setblock ~ ~ ~ stripped_jungle_wood

execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Arm\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Pole\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Bomb\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Gas\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Magma\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Nothing\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Nothing\""}
execute at @e[tag=Boss,scores={Time=4}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Nothing\""}
execute at @e[tag=Boss,scores={Time=4,GeneratorTime=25..}] run kill @e[type=area_effect_cloud,distance=..1]
execute at @e[tag=Boss,scores={Time=4,GeneratorTime=25..}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Generator\""}
execute at @e[tag=Boss,scores={Time=4}] run tag @e[type=area_effect_cloud,limit=1,sort=random,distance=..1] add Choose

execute at @e[tag=Boss,scores={Time=5}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Bomb\""}
execute at @e[tag=Boss,scores={Time=5}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Gas\""}
execute at @e[tag=Boss,scores={Time=5}] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"Magma\""}
execute at @e[tag=Boss,scores={Time=5}] run tag @e[type=area_effect_cloud,limit=1,sort=random,distance=..1] add Choose

execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run tag @s add HitDone
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run tag @s add EnemyNoMove
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run scoreboard players set @s Time 8

execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Arm,tag=Choose,distance=..1] run tag @s add Arm
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Arm,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 4
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Pole,tag=Choose,distance=..1] run tag @s add Pole
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Pole,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 4
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Bomb,tag=Choose,distance=..1] run tag @s add Bomb
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Bomb,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 4
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Gas,tag=Choose,distance=..1] run tag @s add Gas
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Gas,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 10
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Magma,tag=Choose,distance=..1] run tag @s add Magma
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Magma,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 7
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Generator,tag=Choose,distance=..1] run tag @s add Generator
execute as @e[tag=Boss,scores={Time=4..}] at @s if entity @e[name=Generator,tag=Choose,distance=..1] run scoreboard players set @s TimeBoss 2

scoreboard players remove @e[tag=Boss,scores={TimeBoss=1..}] TimeBoss 1
scoreboard players add @e[type=armor_stand,name=FindBomb] TimeBoss 1
execute as @e[tag=Boss,scores={TimeBoss=1..}] run tag @s add HitDone
execute as @e[tag=Boss,scores={TimeBoss=1..}] run tag @s add EnemyNoMove

scoreboard players add @e[type=armor_stand,name=FindBomb] TimeBoss 1
execute as @e[name=PolePlace] run scoreboard players add @s GeneratorTime 1
execute as @e[name=PolePlace,scores={GeneratorTime=25..}] at @s run particle block stone ~ ~ ~ 0.4 0.4 0.4 0.1 100 force
execute as @e[name=PolePlace,scores={GeneratorTime=25..}] at @s run setblock ~ 8 ~ air
execute as @e[name=PolePlace,scores={GeneratorTime=25..}] run kill @s

execute as @e[tag=Boss,scores={TimeBoss=3},tag=Arm] run tellraw @a[tag=Playing] {"text":"\"Don't come closer!\"","color":"yellow"}
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Arm] run tag @e[name=PistonBlockPlace,type=area_effect_cloud,limit=1,sort=random] add MovingBlock
execute as @e[tag=Boss,scores={TimeBoss=2},tag=Arm] at @e[tag=MovingBlock] run setblock ~ ~ ~ air destroy
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Arm] at @e[name=BossStand,limit=1] run spreadplayers ~ ~ 1 2 false @e[tag=MovingBlock]
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Arm] as @e[tag=MovingBlock] at @s run tp @s ~ 8 ~
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Arm] at @e[tag=MovingBlock] run setblock ~ ~ ~ piston[facing=up] destroy
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Arm] run tag @e[tag=MovingBlock] remove MovingBlock
tag @e[tag=Boss,scores={TimeBoss=0},tag=Arm] remove Arm

execute as @e[tag=Boss,scores={TimeBoss=3},tag=Pole] run tellraw @a[tag=Playing] {"text":"\"Stay still...\"","color":"yellow"}
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Pole] at @e[tag=Player] run summon area_effect_cloud ~ ~ ~ {CustomName:"\"PolePlace\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Pole] at @e[name=PolePlace] unless block ~ ~ ~ end_rod run particle block stone ~ ~ ~ 0.4 0.4 0.4 0.1 100 force
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Pole] at @e[name=PolePlace] run setblock ~ ~ ~ end_rod
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Pole] at @e[name=PolePlace] positioned ~ 7 ~ run scoreboard players remove @e[tag=Player,distance=..1] Health 60
tag @e[tag=Boss,scores={TimeBoss=0},tag=Pole] remove Pole

execute as @e[tag=Boss,scores={TimeBoss=3},tag=Bomb] run tellraw @a[tag=Playing] {"text":"\"Let's see how you handle this!\"","color":"yellow"}
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Bomb] at @e[tag=Player] run summon armor_stand ~ ~-1.4 ~ {NoGravity:1,CustomName:"\"FindBomb\"",Invisible:1,ArmorItems:[{},{},{},{id:"tnt",Count:1}]}
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Bomb] at @s run summon armor_stand ~ ~-1.4 ~ {NoGravity:1,CustomName:"\"FindBomb\"",Invisible:1,ArmorItems:[{},{},{},{id:"tnt",Count:1}]}
execute as @e[tag=Boss,scores={TimeBoss=3},tag=Bomb] at @e[tag=Player] run particle cloud ~ ~ ~ 0.3 0.3 0.3 0.01 100 force
execute at @e[type=armor_stand,name=FindBomb,scores={TimeBoss=3..}] run particle explosion ~ ~1 ~ 0.4 0.4 0.4 0.1 10 force
execute at @e[type=armor_stand,name=FindBomb,scores={TimeBoss=3..}] run particle smoke ~ ~1 ~ 0.4 0.4 0.4 0.1 100 force
execute at @e[type=armor_stand,name=FindBomb,scores={TimeBoss=3..}] run playsound entity.dragon_fireball.explode ambient @a ~ ~ ~
execute at @e[type=armor_stand,name=FindBomb,scores={TimeBoss=3..}] run scoreboard players remove @e[tag=Player,distance=..2] Health 50
execute at @e[type=armor_stand,name=FindBomb,scores={TimeBoss=3..}] run scoreboard players remove @e[name=Generator,distance=..2] Health 50
execute as @e[type=armor_stand,name=FindBomb,scores={TimeBoss=3..}] run kill @s
tag @e[tag=Boss,scores={TimeBoss=0},tag=Bomb] remove Bomb

execute as @e[tag=Boss,scores={TimeBoss=9},tag=Gas] run tellraw @a[tag=Playing] {"text":"\"Get! Over! Here!\"","color":"yellow"}
execute as @e[tag=Boss,scores={TimeBoss=1..8},tag=Gas] at @s positioned ~ ~-0.5 ~ unless entity @e[name=PoisonGas,distance=..1] run summon area_effect_cloud ~ 8 ~ {CustomName:"\"PoisonGas\"",Duration:200000}
execute as @e[tag=Boss,scores={TimeBoss=1..8},tag=Gas] at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:move
execute as @e[tag=Boss,scores={TimeBoss=0},tag=Gas] run kill @e[name=PoisonGas,type=area_effect_cloud]
tag @e[tag=Boss,scores={TimeBoss=0},tag=Gas] remove Gas

execute as @e[tag=Boss,scores={TimeBoss=6},tag=Magma] run tellraw @a[tag=Playing] {"text":"\"Be careful where you walk...\"","color":"yellow"}
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] at @s run summon area_effect_cloud ~ ~ ~ {CustomName:"\"MagmaPlace\""}
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] at @e[name=Room,tag=BossRoom] run spreadplayers ~ ~ 1 3 false @e[name=MagmaPlace,type=area_effect_cloud]
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] as @e[name=MagmaPlace,type=area_effect_cloud] at @s run tp @s ~ 8 ~
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] at @e[name=MagmaPlace,type=area_effect_cloud] run particle crit ~ ~ ~ 0.2 0.2 0.2 0.1 50 force
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] at @e[name=MagmaPlace,type=area_effect_cloud] run setblock ~ ~-1 ~ magma_block
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] at @e[name=MagmaPlace,type=area_effect_cloud] run particle flame ~ ~ ~ 0.2 0.2 0.2 0.01 50 force
execute as @e[tag=Boss,scores={TimeBoss=1..5},tag=Magma] as @e[name=MagmaPlace,type=area_effect_cloud] run kill @s
tag @e[tag=Boss,scores={TimeBoss=0},tag=Magma] remove Magma

execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] run tellraw @a[tag=Playing] {"text":"\"You can't hurt me anymore...\"","color":"yellow"}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run summon armor_stand ~ 8 ~ {NoGravity:1,CustomName:"\"Generator\"",Tags:["Enemy"],Invisible:1}
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run scoreboard players set @e[name=Generator,distance=..2,tag=!Secured] Health 50
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run scoreboard players set @e[name=Generator,distance=..2,tag=!Secured] AttackMin 0
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run scoreboard players set @e[name=Generator,distance=..2,tag=!Secured] AttackMax 0
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run scoreboard players set @e[name=Generator,distance=..2,tag=!Secured] DefenseMin 0
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run scoreboard players set @e[name=Generator,distance=..2,tag=!Secured] DefenseMax 0
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run scoreboard players set @e[name=Generator,distance=..2,tag=!Secured] EffectParalyze 1000
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @s run tag @e[name=Generator,distance=..2,tag=!Secured] add Secured
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] at @e[name=Generator] run setblock ~ ~ ~ stripped_jungle_wood
execute as @e[tag=Boss,scores={TimeBoss=1},tag=Generator] run scoreboard players set @s GeneratorTime 0
tag @e[tag=Boss,scores={TimeBoss=0},tag=Generator] remove Generator

execute as @e[tag=Boss,scores={Time=4..,TimeBoss=0}] at @s if entity @e[name=!Nothing,tag=Choose,distance=..1] run scoreboard players set @s Time 0
execute as @e[tag=Boss,scores={Time=4..}] run kill @e[type=area_effect_cloud,distance=..1]