#Cancelling moves?
tag @e[tag=Enemy] remove FirstMove
execute as @e[tag=Enemy] if score @s EffectParalyze matches 1.. run tag @s add EnemyNoMove
execute as @e[tag=Enemy] if score @s EffectFrozen matches 1.. run tag @s add EnemyNoMove
execute as @e[tag=Enemy] if score @s EffectRooted matches 1.. run tag @s add EnemyNoMove
execute as @e[tag=Enemy,tag=Sleep] run tag @s add EnemyNoMove
execute as @e[tag=Enemy,tag=HittingArrow,tag=!HittingBolt] run tag @s add EnemyNoMove
execute as @e[tag=Enemy,tag=Lightning] run tag @s add EnemyNoMove
execute as @e[tag=Enemy,tag=Explode,tag=!Boss] run tag @s add EnemyNoMove

execute as @e[tag=Enemy] if score @s EffectConfuse matches 1.. run tag @s add MoveRandom
execute as @e[tag=Enemy] if score @s EffectAffection matches 1.. run tag @s add HitDone
execute as @e[tag=Enemy] if score Invisibility ListBuff matches 1.. run tag @s add MoveRandom
execute as @e[tag=Enemy] if score Invisibility ListBuff matches 1.. run tag @s add HitDone
execute as @e[tag=Enemy] if score @s EffectParalyze matches 1.. run tag @s add HitDone
execute as @e[tag=Enemy] if score @s EffectFrozen matches 1.. run tag @s add HitDone
execute as @e[tag=Enemy,tag=Calm] run tag @s add MoveRandom
execute as @e[tag=Enemy,tag=Calm] run tag @s add HitDone
execute as @e[tag=Enemy,tag=Teleportation] run tag @s add MoveTeleport
execute as @e[tag=Enemy,tag=Teleportation] run tag @s add HitDone
execute as @e[tag=Enemy,tag=Explode,tag=!Boss] run tag @s add HitDone

execute as @e[tag=Enemy] if score @s EffectRage matches 1.. run tag @s add Amok
execute as @e[tag=Enemy,type=wither_skeleton] if score Wither ListBuff matches 1.. run tag @s add HitDone
execute as @e[tag=Enemy,type=wither_skeleton] if score Wither ListBuff matches 1.. run tag @s add Flee
scoreboard players add @e[tag=Explode,tag=!Boss] Time 1
execute at @e[tag=Explode,scores={Time=3},tag=!Boss] run playsound minecraft:entity.creeper.primed ambient @a
execute at @e[tag=Explode,scores={Time=4..},tag=!Boss] run scoreboard players remove @e[tag=Player,distance=..2,tag=!P_Buster] Health 80
execute at @e[tag=Explode,scores={Time=4..},tag=!Boss] run scoreboard players remove @e[tag=Enemy,distance=..2,type=!armor_stand] Health 50
execute at @e[tag=Explode,scores={Time=4..},tag=!Boss] run scoreboard players remove @e[tag=Friend,distance=..2,type=!armor_stand] Health 50
execute at @e[tag=Explode,scores={Time=4..},tag=!Boss] run particle explosion ~ ~ ~ 0.5 0.5 0.5 0.1 10 force @a[tag=PAR]
execute at @e[tag=Explode,scores={Time=4..},tag=!Boss] run playsound entity.dragon_fireball.explode ambient @a ~ ~ ~
execute as @e[tag=Explode,scores={Time=4..},tag=!Boss] run kill @s

#Attacking other enemies?
execute as @e[tag=Enemy,tag=!HitDone,tag=Amok] at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Enemy,distance=1..2] run tag @s add Hitting

#Projectile?
execute as @e[tag=Enemy,tag=!HitDone,tag=Shooting,tag=!Sleep,tag=!Amok] unless score @s EffectCursed matches 1.. at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Player,distance=2..7] run function enemy:shootbow
execute as @e[tag=Enemy,tag=!HitDone,tag=Casting,tag=!Sleep,tag=!Amok] unless score @s EffectCursed matches 1.. at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Player,distance=2..7] run function enemy:shootbolt
execute as @e[tag=Enemy,tag=!HitDone,tag=Fireball,tag=!Sleep,tag=!Amok] unless score @s EffectCursed matches 1.. at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Player,distance=2..7] run function enemy:shootfireball
execute as @e[tag=Enemy,tag=!HitDone,tag=Icebeam,tag=!Sleep,tag=!Amok] unless score @s EffectCursed matches 1.. at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Player,distance=2..7] run function enemy:shootice
execute as @e[tag=Enemy,tag=!HitDone,tag=Lightning,tag=!Sleep,tag=!Amok] at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:lightning
execute as @e[tag=Enemy,tag=!HitDone,tag=Evoker,tag=!Sleep,tag=!Amok] at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:evoker

#What if there is a player nearby?
execute as @e[tag=Enemy,tag=!HitDone] at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Player,distance=..2] run tag @s add Hitting
execute as @e[tag=Enemy,tag=!HitDone] at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Friend,distance=..2] run tag @s add Hitting
execute as @e[tag=Enemy,tag=!HitDone,tag=Hitting,tag=!HittingArrow,tag=!HittingBolt,tag=!HittingFlame,tag=!HittingIce] run scoreboard players set @s HitTime 10
execute as @e[tag=Enemy,tag=!HitDone,tag=Hitting] as @e[tag=double,tag=!HitDone] unless score @s EffectCursed matches 1.. run tag @s add HitTwo
execute as @e[tag=Enemy,tag=!HitDone,tag=Hitting,tag=double] unless score @s EffectCursed matches 1.. run scoreboard players add SpreadTime Time 22
execute as @e[tag=Enemy,tag=!HitDone,tag=Hitting,tag=!double,tag=!HittingArrow,tag=!HittingBolt,tag=!HittingIce] run scoreboard players add SpreadTime Time 10
execute as @e[tag=Enemy,tag=!HitDone,tag=Hitting,tag=double,scores={EffectCursed=1..}] run scoreboard players add SpreadTime Time 10

#What if there is no player nearby?
execute as @e[tag=Enemy,tag=!EnemyNoMove,tag=!Hitting,tag=MoveRandom] at @s run function enemy:moverandom
execute at @e[tag=Player] as @e[tag=Enemy,tag=!EnemyNoMove,tag=!Hitting,distance=..20,tag=Flee] unless score @s EffectCursed matches 1.. at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:flee
execute at @e[tag=Player] as @e[tag=Enemy,tag=!EnemyNoMove,tag=!Hitting,distance=..20,tag=Teleport] unless score @s EffectCursed matches 1.. at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:teleport
execute at @e[tag=Player] as @e[tag=Enemy,tag=!EnemyNoMove,tag=!Hitting,distance=..20,tag=!MoveRandom] at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:move

execute at @e[tag=Player] as @e[tag=Enemy,tag=!EnemyNoMove,tag=MoveTeleport] at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:teleport
execute at @e[tag=Player] as @e[tag=Enemy,tag=Teleportation2] at @s align xz positioned ~0.5 ~-0.5 ~0.5 run function enemy:teleport
execute as @e[tag=MoveTeleport] at @s run summon area_effect_cloud ~ 8 ~ {CustomName:"\"LightningTest\"",Duration:20000}
execute as @e[tag=MoveTeleport] as @e[name=LightningTest] at @s run tp @s ~ ~ ~ facing entity @e[tag=Player,limit=1]
execute as @e[tag=MoveTeleport] run tag @s remove Teleportation
execute as @e[tag=MoveTeleport] run tag @s add Lightning

#What if there is a enemy nearby an ally?
execute as @e[tag=Friend,tag=!HitDone] at @s align xz positioned ~0.5 ~-0.5 ~0.5 as @e[tag=Enemy,distance=..2] run tag @s add Target
execute as @e[tag=Friend,tag=!HitDone] at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Enemy,distance=..2] run tag @s add Hitting
execute as @e[tag=Friend,tag=!HitDone,tag=Hitting] run scoreboard players set @s HitTime 10
execute as @e[tag=Friend,tag=!HitDone,tag=Hitting] run scoreboard players add SpreadTime Time 10

#What if there is no enemy nearby an ally?
execute at @e[tag=Player] as @e[tag=Friend,tag=!EnemyNoMove,tag=!Hitting] at @s align xz positioned ~0.5 ~-0.5 ~0.5 unless entity @e[tag=Player,distance=..2] run tag @s add FriendMoveX
execute at @e[tag=Player] as @e[tag=Friend,tag=!EnemyNoMove,tag=!Hitting] at @s align xz positioned ~0.5 ~-0.5 ~0.5 if entity @e[tag=Enemy,distance=..5] run tag @s add FriendMoveX
execute as @e[tag=Friend,tag=FriendMoveX] at @s run function friend:move

execute if score AttackSpeed Math matches ..0 run scoreboard players set MoveSpeed Math 10
execute if score AttackSpeed Math matches ..0 if score Speed ListBuff matches 1.. run scoreboard players add MoveSpeed Math 10
execute if score AttackSpeed Math matches ..0 if score Shadowed ListBuff matches 1.. run scoreboard players add MoveSpeed Math 30
execute if score AttackSpeed Math matches ..0 if entity @e[tag=Player,tag=RageMode] run scoreboard players add MoveSpeed Math 10
tag @e[tag=Enemy] remove EnemyNoMove
tag @e[tag=Enemy] remove Amok
tag @e[tag=Enemy] remove MoveRandom
tag @e[tag=Enemy] remove MoveTeleport
tag @a add EnemyHit
tag @a remove OtherMove
execute at @e[tag=Enemy,scores={EffectAffection=1..}] run particle heart ~ ~0.5 ~ 0 0 0 0.1 1 force