#Basic joining!
execute at @a[tag=Playing,tag=!Using,tag=!CutScene,gamemode=!spectator] run tp @e[type=villager,name=Click] ~ ~0.5 ~
execute at @a[tag=Playing,tag=CutScene] run tp @e[type=villager,name=Click] ~ ~5 ~
effect give @e[type=!armor_stand] resistance 10 100 true
effect give @a saturation 10 100 true
execute if entity @e[tag=NightVision] run effect give @a[tag=Playing,tag=!Lobby] night_vision 30 0 true
execute as @a[tag=!In] run function main:join
execute as @a[scores={Leave=1..}] run function main:leave
execute unless entity @a[tag=ResetLobby] if entity @a[tag=!Reset] unless entity @a[tag=Playing] run function main:leave2
execute if entity @a[tag=Playing] run tag @a remove Reset

#Bossbars
execute unless entity @a[tag=Playing,tag=Lobby] store result bossbar minecraft:health value run scoreboard players get @e[tag=Player,limit=1] Health
execute unless entity @a[tag=Playing,tag=Lobby] store result bossbar minecraft:health max run scoreboard players get @e[tag=Player,limit=1] HealthMax
execute unless entity @a[tag=Playing,tag=Lobby] store result bossbar minecraft:experience value run scoreboard players get @e[tag=Player,limit=1] Experience
execute unless entity @a[tag=Playing,tag=Lobby] store result bossbar minecraft:experience max run scoreboard players get @e[tag=Player,limit=1] ExperienceMax
execute unless entity @a[tag=Playing,tag=Lobby] store result bossbar minecraft:magic value run scoreboard players get @e[tag=Player,limit=1] Magic
execute unless entity @a[tag=Playing,tag=Lobby] store result bossbar minecraft:magic max run scoreboard players get @e[tag=Player,limit=1] MagicMax

scoreboard players set @e[tag=Enemy,tag=!Secured] AttackMin 2
scoreboard players set @e[tag=Enemy,tag=!Secured] AttackMax 4
scoreboard players set @e[tag=Enemy,tag=!Secured] DefenseMin 0
scoreboard players set @e[tag=Enemy,tag=!Secured] DefenseMax 1
scoreboard players set @e[tag=Enemy,tag=!Secured] Health 10
tag @e[tag=Enemy,tag=!Secured] add Secured

kill @e[tag=!Secured,type=magma_cube]
kill @e[tag=!Secured,type=slime]

scoreboard players set MobCount Math 0
execute as @e[tag=Enemy] run scoreboard players add MobCount Math 1
execute at @e[name=Room,tag=Darkx] run effect give @e[tag=Enemy,distance=8..] invisibility 10 0 true
execute at @e[name=Room,tag=Light] run effect clear @e[tag=Enemy,distance=..8] invisibility
effect give @e[tag=Enemy,tag=Sleep] invisibility 10 0 true
effect clear @e[tag=Enemy,tag=!Sleep] invisibility

execute at @e[type=tnt] run scoreboard players remove @e[tag=Player,distance=..2,tag=!P_Buster] Health 50
execute at @e[type=tnt] run scoreboard players remove @e[tag=Enemy,distance=..2,type=!armor_stand] Health 25
execute at @e[type=tnt] run scoreboard players remove @e[tag=Friend,distance=..2,type=!armor_stand] Health 25
execute at @e[type=tnt] run particle explosion ~ ~ ~ 0.5 0.5 0.5 0.1 10 force @a[tag=PAR]
execute at @e[type=tnt] run playsound entity.dragon_fireball.explode ambient @a ~ ~ ~
execute as @e[type=tnt] run kill @s

execute at @e[tag=Playing,tag=!Using,tag=!Lobby] as @e[type=item,distance=..6,nbt=!{Item:{tag:{Main:1b}}},nbt=!{Item:{tag:{Ability:1b}}}] run scoreboard players add @s TimeFriend 1
execute as @e[type=item,nbt={Item:{tag:{Main:1b}}}] run data merge entity @s {PickupDelay:0s}
execute as @e[type=item,nbt={Item:{tag:{Ability:1b}}}] run data merge entity @s {PickupDelay:0s}
execute at @e[tag=Lobby] as @e[type=item,distance=..10] run data merge entity @s {PickupDelay:0s}
execute as @e[type=item,scores={TimeFriend=10..}] at @e[tag=Player] run tp @s ^ ^ ^
execute as @e[type=item,tag=!Aligned,scores={TimeFriend=10..}] run data merge entity @s {Age:-32000}
scoreboard players set @e[type=item,scores={TimeFriend=10..}] TimeFriend 0
execute unless entity @e[tag=Using] as @e[type=item,tag=!Aligned] at @s align xz run tp @s ~0.5 ~ ~0.5
tag @e[type=item] add Aligned

execute if entity @e[tag=Hints] run function main:lobby/hints
execute if entity @e[name=LobbySettings,tag=Challenge5] run tag @e[tag=Identified] remove Identified

scoreboard players add @e[name=PlatePusher,type=armor_stand] Time 1
kill @e[name=PlatePusher,scores={Time=10..}]
scoreboard players add @e[name=PlatePusher2,type=armor_stand] Time 1
kill @e[name=PlatePusher2,scores={Time=5..}]
scoreboard players add @e[name=PlatePusher3,type=armor_stand] Time 1
kill @e[name=PlatePusher3,scores={Time=3..}]

execute if score CurrentFloor MathCurrent matches 2 at @e[type=armor_stand,tag=Secret2] if block ~ 8 ~ iron_trapdoor[powered=true] run particle cloud ~ 8.5 ~ 0.3 0.2 0.3 0.04 10 force
execute if score CurrentFloor MathCurrent matches 2 at @e[type=armor_stand,tag=Secret2] if block ~ 8 ~ iron_trapdoor[powered=true] run setblock ~ 8 ~ structure_void destroy

#Non-gameplay effects (aestathiccs)
execute at @e[scores={EffectFire=1..}] run particle flame ~ ~ ~ 0.1 0.5 0.1 0.01 5 force @a[tag=PAR]
execute at @e[scores={EffectInjured=1..}] run particle item_slime ~ ~ ~ 0.1 0.5 0.1 0.01 3 force @a[tag=PAR]
execute at @e[scores={EffectConfuse=1..}] run particle crit ~ ~ ~ 0.3 0.5 0.3 0.01 3 force @a[tag=PAR]
execute at @e[scores={EffectPoisoned=1..}] run particle dust 0 1 0 1 ~ ~0.5 ~ 0.2 0 0.2 0.01 1 force @a[tag=PAR]
execute at @e[scores={EffectFrozen=1..}] run particle enchanted_hit ~ ~ ~ 0.3 0.3 0.3 0.01 30 force @a[tag=PAR]
execute at @e[scores={EffectRooted=1..}] run particle block oak_leaves ~ ~ ~ 0.3 0 0.3 0.01 5 force @a[tag=PAR]
execute at @e[scores={EffectRage=1..}] run particle dust 1 0 0 1 ~ ~0.5 ~ 0.2 0 0.2 0.01 1 force @a[tag=PAR]
execute at @e[tag=RageMode] run particle dust 1 0 0 1 ~ ~0.5 ~ 0.4 0.5 0.4 0.01 5 force @a[tag=PAR]
execute at @e[tag=SoulDrain] run particle dust 0 0.5 1 1 ~ ~0.5 ~ 0.4 0.5 0.4 0.01 5 force @a[tag=PAR]
execute at @e[scores={EffectWeakness=1..}] run particle splash ~ ~ ~ 0.2 0.2 0.2 0.1 5 force @a[tag=PAR]
execute at @e[scores={EffectCursed=1..}] run particle dragon_breath ~ ~ ~ 0.1 0.5 0.1 0.01 1 force @a[tag=PAR]
execute at @e[scores={EffectParalyze=1..},name=!Dummy,name=!Generator] run particle dust 1 0 1 1 ~ ~0.5 ~ 0.2 0 0.2 0.01 1 force @a[tag=PAR]
execute at @e[tag=Enraged,tag=!Sleep] run particle dust 1 0 1 1 ~ ~0.5 ~ 0.3 0.3 0.3 0.01 2 force @a[tag=PAR]
execute at @e[tag=Calm,tag=!Sleep] run particle dust 0 1 1 1 ~ ~0.5 ~ 0.3 0.3 0.3 0.01 2 force @a[tag=PAR]
execute at @e[type=armor_stand,name=Spirit,tag=!Sleep] run particle smoke ~ ~1 ~ 0.3 0.7 0.3 0.01 20 force
execute at @e[type=skeleton,name=Ghost,tag=!Sleep] run particle cloud ~ ~0.2 ~ 0.2 0.6 0.2 0.01 5 force
execute at @e[type=skeleton,name=Reaper,tag=!Sleep] run particle smoke ~ ~0.2 ~ 0.3 0.7 0.3 0.01 20 force
execute at @e[tag=Smoked] run particle smoke ~ ~ ~ 0.3 0.3 0.3 0.01 10 force
execute if score Blinded ListBuff matches 1.. at @e[tag=Player] run particle smoke ~ ~ ~ 0.3 0.3 0.3 0.01 10 force @a[tag=PAR]
execute at @e[name=WitchGas,scores={Time=1..}] run particle dust 1 0 1 1 ~ ~0.5 ~ 0.3 0.2 0.3 0.02 3 force @a[tag=PAR]
execute at @e[name=WitchGas,scores={Time=2..}] positioned ~ ~-0.5 ~ if entity @e[tag=Player,distance=..1] run scoreboard players set Paralyzed ListBuff 3
execute at @e[name=PoisonGas] run particle dust 0 1 0 1 ~ ~0.5 ~ 0.3 0.2 0.3 0.02 3 force @a[tag=PAR]
execute at @e[name=PoisonGas] positioned ~ ~-0.5 ~ if entity @e[tag=Player,distance=..1] run scoreboard players set Poison ListBuff 5
execute at @e[name=PoisonGas] positioned ~ ~-0.5 ~ if entity @e[tag=Player,distance=..1] run scoreboard players set @e[tag=Player,distance=..1] DamagePoison 5
execute as @e[name=PoisonGas] at @s positioned ~ ~-0.5 ~ if entity @e[tag=Player,distance=..1] run kill @s
execute at @e[name=Generator,type=armor_stand] run particle dust 1 1 0 1 ~ ~0.5 ~ 0.3 0.3 0.3 0.01 1 force @a[tag=PAR]
execute at @e[tag=Player,tag=LobbyDelete] run particle dust 10 10 10 1 ~ ~1 ~ 0.4 0.4 0.4 0.01 3 force @a[tag=PAR]
execute at @e[tag=Etheral,type=illusioner] run particle dust 0 1 1 1 ~ ~ ~ 0.4 0.4 0.4 0.01 3 force
execute at @e[type=armor_stand,name=Dharkon,tag=!nosmoke] run particle smoke ~ ~1 ~ 0.3 0.7 0.3 0.01 20 force
execute at @e[type=stray,name=Excaliron] run particle dust 0 0.5 0.8 1 ~ ~0.5 ~ 0.3 0.2 0.3 0.01 5 force
execute at @e[type=stray,name=Excaliron] run particle dust 0 0.8 1 1 ^0.35 ^0.9 ^0.3 0 0 0 0.01 3 force
execute at @e[type=stray,name=Excaliron] run particle dust 0 0.8 1 1 ^-0.35 ^0.8 ^0.3 0.1 0 0.1 0.01 3 force
execute at @e[type=stray,name=Excaliron,tag=SpiritRealm] run particle dust 0 0.8 1 1 ~ ~1 ~ 0.5 0.5 0.5 0.01 20 force
execute at @e[type=pillager,tag=Finale] run particle witch ~ ~0.5 ~ 0.2 0 0.2 0.01 5 force
execute at @e[type=area_effect_cloud,name=TeleportVeritas] run particle witch ~ ~0.5 ~ 0.2 0 0.2 0.01 5 force
execute at @e[type=pillager,name=Veritas,tag=NoPlayer] run particle witch ~ ~ ~ 0 0 0 0.01 2 force
execute at @e[type=area_effect_cloud,nbt={Duration:200000},name=!MoveRight,name=!Walker,tag=!LobbyDelete] run particle mycelium ~ 8.5 ~ 0.3 0 0.3 0.1 10 force

execute unless score Invisibility ListBuff matches 1.. run effect clear @e[tag=Player] invisibility
execute unless score Invisibility ListBuff matches 1.. run effect clear @e[tag=Player] glowing
execute if score Invisibility ListBuff matches 1.. run effect give @e[tag=Player] invisibility 1 0 true
execute if score Invisibility ListBuff matches 1.. run effect give @e[tag=Player] glowing 1 0 true
execute if score Ablaze ListBuff matches 1.. at @e[tag=Player] run particle flame ~ ~ ~ 0.2 1 0.2 0.01 10 force @a[tag=PAR]
execute at @e[type=armor_stand,name=ToolBomb] run particle smoke ~ ~1.5 ~ 0.2 0 0.2 0.01 10 force @a[tag=PAR]
execute at @e[tag=P_Eye] run effect give @e[tag=Enemy,distance=..8,tag=!Boss] glowing 1 0 true
execute at @e[tag=P_Eye] run team join GlowCompass @e[tag=Enemy,distance=..8]
effect give @e[tag=Invisible] invisibility 1 0 true

execute if entity @a[tag=!Lobby,tag=Playing] run function path:timer
execute as @a[scores={Sneak=1..}] if entity @e[tag=StepCounter,tag=!TimeCounter] run title @s actionbar ["",{"translate":"message.settings.count1","color":"gold"},{"score":{"name":"Steps","objective":"TimeSteps"},"color":"green","bold":"true"}]
execute as @a[scores={Sneak=1..}] if entity @e[tag=!StepCounter,tag=TimeCounter] run title @s actionbar ["",{"translate":"message.settings.count2","color":"red"},{"score":{"name":"Hours","objective":"TimeSteps"},"color":"green","bold":"true"},{"text":":"},{"score":{"name":"Minutes","objective":"TimeSteps"},"color":"green","bold":"true"},{"text":":"},{"score":{"name":"Seconds","objective":"TimeSteps"},"color":"green","bold":"true"}]
execute as @a[scores={Sneak=1..}] if entity @e[tag=StepCounter,tag=TimeCounter] run title @s actionbar ["",{"translate":"message.settings.count2","color":"red"},{"score":{"name":"Hours","objective":"TimeSteps"},"color":"green","bold":"true"},{"text":":"},{"score":{"name":"Minutes","objective":"TimeSteps"},"color":"green","bold":"true"},{"text":":"},{"score":{"name":"Seconds","objective":"TimeSteps"},"color":"green","bold":"true"},{"text":" | "},{"translate":"message.settings.count1","color":"gold"},{"score":{"name":"Steps","objective":"TimeSteps"},"color":"green","bold":"true"}]
execute as @a[scores={Sneak=1..}] run scoreboard players set @s Sneak 0

#Tutorial
execute if entity @a[tag=Tutorial] run function main:tutorial/core

#Shopkeepers
execute as @e[tag=Shopkeep,tag=!Loaded] at @s positioned ~ 8 ~ if entity @e[tag=Player,distance=..3] at @s run function math:shopitems
execute as @e[tag=ShopKeep] at @s unless score @s EffectFrozen matches 1.. unless score @s EffectParalyze matches 1.. unless score @s EffectConfuse matches 1.. unless score Invisibility ListBuff matches 1.. unless score Shadowed ListBuff matches 1.. run tp @s ~ ~ ~ facing entity @e[tag=Player,limit=1,distance=..5]
execute as @e[tag=Shopkeep2,tag=!Loaded] at @s positioned ~ 8 ~ if entity @e[tag=Player,distance=..3] at @s run function math:shopitems2
execute as @e[tag=ShopKeep2] at @s unless score @s EffectFrozen matches 1.. unless score @s EffectParalyze matches 1.. unless score @s EffectConfuse matches 1.. unless score Invisibility ListBuff matches 1.. unless score Shadowed ListBuff matches 1.. run tp @s ~ ~ ~ facing entity @e[tag=Player,limit=1,distance=..5]
execute as @a[scores={TriggerShop=1..3}] run function main:talk/shop
execute as @a[scores={TriggerShop=4..6}] run function main:talk/shop2
execute as @a[scores={TriggerLobby=1..}] run function main:lobby/trigger
execute as @a[scores={TriggerTransmute=1..}] run function main:transmute
execute as @a[scores={TriggerStatue=1..}] run function main:statue
execute as @a[scores={TriggerTut=2}] run give @a[tag=Playing] pink_dye{display:{Name:"{\"text\":\"Restart\",\"color\":\"red\"}",Lore:['{"text":"§4§l§oGame Over."}','{"text":"§7§oRight-click to restart."}']}}
execute as @a[scores={TriggerTut=2}] run tag @s remove Tutorial1
execute as @a[scores={TriggerTut=2}] run tag @s remove Tutorial2
execute as @a[scores={TriggerTut=2}] run tag @s remove Tutorial3
execute as @a[scores={TriggerTut=2}] run tag @s remove Tutorial4
execute as @a[scores={TriggerTut=2}] run tag @s remove Tutorial5
execute as @a[scores={TriggerTut=1..2}] run fill 41 11 -1 37 11 3 air
execute as @a[scores={TriggerTut=1..2}] run fill 39 8 -1 39 10 -1 air
execute as @a[scores={TriggerTut=1..2}] run tag @e[name=LobbyUnlocks] add Floor0
execute as @a[scores={TriggerTut=1}] run function main:tutorial/first
execute as @a[scores={TriggerTut=2}] run scoreboard players set @s TriggerTut 0

#Rightclick detection
scoreboard players set @a Rightclick2 0
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{id:"minecraft:feather"}}] Rightclick2 1
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{id:"minecraft:firework_star"}}] Rightclick2 2
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Spell:1b}}}] Rightclick2 3
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Scroll:1b}}}] Rightclick2 4
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Potion:1b}}}] Rightclick2 5
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{id:"minecraft:stick"}}] Rightclick2 6
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Food:1b}}}] Rightclick2 7
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Tool:1b}}}] Rightclick2 8
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Weapon:1b}}}] Rightclick2 9
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Armor:1b}}}] Rightclick2 10
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Orb:1b}}}] Rightclick2 11
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Book:1b}}}] Rightclick2 12
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Ability:1b}}}] Rightclick2 13
scoreboard players set @a[scores={Rightclick=1..},nbt={SelectedItem:{tag:{Medal:1b}}}] Rightclick2 14
execute if entity @a[scores={Rightclick=1..},nbt={SelectedItem:{id:"minecraft:pink_dye"}}] run function main:lobby/loss
execute unless entity @e[tag=Player] run scoreboard players set @a Rightclick2 0
scoreboard players set @a[scores={Rightclick=1..},tag=Lobby,tag=!Lobby2] Rightclick2 1
execute if entity @a[scores={Rightclick2=1},tag=Moving] run tag @a add Quit
scoreboard players set @a[tag=Move] Rightclick2 0

#Move cancelling
execute if entity @a[scores={Rightclick2=1}] unless score Levitation ListBuff matches 1.. at @e[tag=Player] if block ~ ~-1 ~ slime_block run tag @a add NoMoveSlime
execute if entity @a[tag=Moving,tag=MoveMore] unless score Levitation ListBuff matches 1.. at @e[tag=Player] if block ~ ~-1 ~ slime_block run tag @a add NoMoveSlime
execute if entity @a[scores={Rightclick2=1}] unless score Levitation ListBuff matches 1.. at @e[tag=Player] if block ~ ~ ~ cobweb run tag @a add NoMoveSlime
execute if entity @a[tag=Moving,tag=MoveMore] unless score Levitation ListBuff matches 1.. at @e[tag=Player] if block ~ ~ ~ cobweb run tag @a add NoMoveSlime

execute if entity @a[tag=NoMoveSlime] at @e[tag=Player] if block ~ ~-1 ~ slime_block run setblock ~ ~-1 ~ lime_concrete
execute if entity @a[tag=NoMoveSlime] at @e[tag=Player] run fill ~ ~ ~ ~ ~1 ~ air replace cobweb
execute if entity @a[tag=NoMoveSlime] run scoreboard players set @a Rightclick2 0
execute if entity @a[tag=NoMoveSlime] run function path:after
execute if entity @a[tag=NoMoveSlime] run kill @e[name=Start,type=armor_stand]
execute if entity @a[tag=NoMoveSlime] at @e[tag=Player] run summon armor_stand ~ ~ ~ {CustomName:"\"Start\"",Invisible:1}
execute if entity @a[tag=NoMoveSlime] run function main:turnend
execute if entity @a[tag=NoMoveSlime] run tag @a[tag=Playing] add Move
execute if entity @a[tag=NoMoveSlime] run tag @a remove NoMoveSlime

execute if score MoveTime Time matches 1.. if entity @a[tag=Quit] run scoreboard players set @a Rightclick2 0
execute if score MoveTime Time matches 1.. if entity @a[tag=Quit] run function path:after
execute if score MoveTime Time matches 1.. if entity @a[tag=Quit] run kill @e[name=Start,type=armor_stand]
execute if score MoveTime Time matches 1.. if entity @a[tag=Quit] at @e[tag=Player] run summon armor_stand ~ ~ ~ {CustomName:"\"Start\"",Invisible:1}
execute if score MoveTime Time matches 1.. if entity @a[tag=Quit] run function main:turnend
execute if score MoveTime Time matches 1.. if entity @a[tag=Quit] run tag @a remove Quit
execute if score MoveTime Time matches 1.. run scoreboard players set MoveTime Time 0

execute if score Paralyzed ListBuff matches 1.. run scoreboard players set @a Rightclick2 0
execute if score AttackSpeed Math matches 1.. run scoreboard players set @a Rightclick2 0

#No-Go cancelling
execute if entity @a[scores={Rightclick=1..},tag=!Lobby] at @e[type=shulker,name=Cursor] positioned ~ ~-3 ~ unless entity @e[name=Room,distance=..5,tag=Discovered] run title @a[tag=Playing] actionbar {"translate":"main.error1","color":"red"}
execute if entity @a[scores={Rightclick=1..},tag=!Lobby] at @e[type=shulker,name=Cursor] positioned ~ ~-3 ~ unless entity @e[name=Room,distance=..5,tag=Discovered] run scoreboard players set @a[tag=Playing] Rightclick2 0

#Cancelling
execute if entity @a[scores={Rightclick2=9}] if entity @e[tag=Player,tag=CursedWeapon] run title @a[tag=Playing] actionbar {"translate":"main.error2","color":"dark_purple"}
execute if entity @a[scores={Rightclick2=9}] if entity @e[tag=Player,tag=CursedWeapon] run scoreboard players set @a Rightclick2 0

execute if entity @a[scores={Rightclick2=10}] if entity @e[tag=Player,tag=CursedArmor] run title @a[tag=Playing] actionbar {"translate":"main.error3","color":"dark_purple"}
execute if entity @a[scores={Rightclick2=10}] if entity @e[tag=Player,tag=CursedArmor] run scoreboard players set @a Rightclick2 0

execute if entity @a[scores={Rightclick2=1}] if score Rooted ListBuff matches 1.. at @e[type=shulker,name=Cursor] unless entity @e[tag=Player,distance=..1] run title @a[tag=Playing] actionbar {"translate":"main.error4","color":"red"}
execute if entity @a[scores={Rightclick2=1}] if score Rooted ListBuff matches 1.. at @e[type=shulker,name=Cursor] unless entity @e[tag=Player,distance=..1] run scoreboard players set @a Rightclick2 0

execute if entity @a[scores={Rightclick2=2},tag=!P_Etheral] if score Shadowed ListBuff matches 1.. run title @a[tag=Playing] actionbar {"translate":"main.error5","color":"red"}
execute if entity @a[scores={Rightclick2=2},tag=!P_Etheral] if score Shadowed ListBuff matches 1.. run scoreboard players set @a Rightclick2 0
execute if entity @a[scores={Rightclick2=2},tag=!P_Etheral] if score Confused ListBuff matches 1.. run title @a[tag=Playing] actionbar {"translate":"main.error6","color":"red"}
execute if entity @a[scores={Rightclick2=2},tag=!P_Etheral] if score Confused ListBuff matches 1.. run scoreboard players set @a Rightclick2 0

#Use the Cancel button for Use.
execute if entity @a[scores={RightclickUse=1..},tag=Playing] as @e[name=MineRoom] at @s if block ~ 15 ~ chest run clone ~ 15 ~ ~ 15 ~ ~ 8 ~
execute if entity @a[scores={RightclickUse=1..},tag=Playing] as @e[name=MineRoom] at @s if block ~ 15 ~ chest positioned ~ 15 ~ run kill @e[type=item,distance=..3]
execute if entity @a[scores={RightclickUse=1..},tag=Playing] at @e[tag=RoomSpecial] unless block ~ 15 ~ air run particle cloud ~ 15 ~ 0.5 0.5 0.5 0.01 100 force @a[tag=PAR]
execute if entity @a[scores={RightclickUse=1..},tag=Playing] at @e[tag=RoomSpecial] run setblock ~ 15 ~ air
execute if entity @a[scores={RightclickUse=1..},tag=Playing] if score TutorialTime Time matches 3103 run tag @a remove STOP
tag @a[scores={RightclickUse=1..},tag=Playing] remove Using
replaceitem entity @a[scores={RightclickUse=1..},tag=Playing] weapon.mainhand stick{Main:1b,display:{Lore:['{"text":"§7§lMain Action"}','{"text":"§7Use on an entity to get its stats."}','{"text":"§7Use on a nearby item to grab it."}','{"text":"§7Use on a nearby utility to use it."}'],Name:"{\"translate\":\"inv.main.use\",\"italic\":\"false\",\"bold\":\"true\"}"}}
tag @a[scores={RightclickUse=1..},tag=Playing] remove Using

execute as @a[scores={RightclickUse=1..},limit=1] unless entity @a[tag=Playing] run function main:lobby/load
execute as @a[scores={RightclickUse=1..},limit=1,sort=nearest,tag=!Playing] run tag @s add Lobby
execute as @a[scores={RightclickUse=1..},limit=1,sort=nearest,tag=!Playing] run tag @a remove Reset
execute as @a[scores={RightclickUse=1..},limit=1,sort=nearest,tag=!Playing] run tag @s add Playing

scoreboard players set @a[scores={RightclickUse=1..},tag=Playing] RightclickUse 0

#Select action based on held item.
function path:shulker1
execute if entity @a[scores={Rightclick2=1}] run function main:clickmove
execute if entity @a[scores={Rightclick2=2}] run function main:clickattack
execute if entity @a[scores={Rightclick2=3}] as @a[scores={Rightclick2=3}] run function main:clickspell
execute if entity @a[scores={Rightclick2=4}] as @a[scores={Rightclick2=4}] run function main:clickscroll
execute if entity @a[scores={Rightclick2=5}] as @a[scores={Rightclick2=5}] run function main:clickpotion
execute if entity @a[scores={Rightclick2=6}] run function main:clickuse
execute if entity @a[scores={Rightclick2=7}] run function main:clickfood
execute if entity @a[scores={Rightclick2=8}] run function main:clicktool
execute if entity @a[scores={Rightclick2=9}] run function main:clickweapon
execute if entity @a[scores={Rightclick2=10}] run function main:clickarmor
execute if entity @a[scores={Rightclick2=11}] run function main:clickorb
execute if entity @a[scores={Rightclick2=12}] run function main:clickbook
execute if entity @a[scores={Rightclick2=13}] run function main:clickability
execute if entity @a[scores={Rightclick2=14}] run scoreboard players set Ending Talk 0
execute if entity @a[scores={Rightclick2=14}] run tag @a[tag=Playing] add Ending1
execute if entity @a[scores={Rightclick2=14}] run tag @a[tag=Playing] add CutScene
scoreboard players set @a Rightclick 0
tag @a remove Click

#Death handling.
execute as @e[tag=Enemy,scores={Health=..0},tag=!Final] at @s run function main:death/loot
kill @e[tag=Friend,scores={Health=..0},tag=!Final]

execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Dharkon] unless entity @e[tag=FinalBoss1] run scoreboard players set Dharkon2 Talk 0
execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Dharkon] run tag @e[tag=Player] add FinalBoss1
execute if entity @e[tag=FinalBoss1] run function main:talk/dharkon2

execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Excaliron] unless entity @e[tag=FinalBoss2] run scoreboard players set Excaliron3 Talk 0
execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Excaliron] run tag @e[tag=Player] add FinalBoss2
execute if entity @e[tag=FinalBoss2] run function main:talk/excaliron3

execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Veritas] unless entity @e[tag=FinalBoss3] run scoreboard players set Veritas3 Talk 0
execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Veritas] run tag @e[tag=Player] add FinalBoss3
execute if entity @e[tag=FinalBoss3] run function main:talk/veritas3

execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Dionae] unless entity @e[tag=FinalBoss3] run scoreboard players set Dionae3 Talk 0
execute as @e[tag=Enemy,scores={Health=..0},tag=Final,name=Dionae] run tag @e[tag=Player] add FinalBoss3
execute if entity @e[tag=FinalBoss3] run function main:talk/dionae3

scoreboard players set @e[tag=Player,scores={ExperienceLevel=..0}] Health 0
execute as @e[tag=Player,scores={Health=..0}] run function main:death/player

#Use utilities.
execute as @e[name=BrewingRoom] at @s if block ~ 15 ~ blue_carpet run function main:use/brew
execute as @e[name=EnchantRoom] at @s if block ~ 15 ~ purple_carpet run function main:use/enchant
execute as @e[name=CraftRoom] at @s if block ~ 15 ~ brown_carpet run function main:use/craft
execute as @e[name=SmiteRoom] at @s if block ~ 15 ~ light_gray_carpet run function main:use/smite
execute as @e[name=CutRoom] at @s if block ~ 15 ~ gray_carpet run function main:use/cut
execute as @e[name=SummonRoom] at @s if block ~ 15 ~ green_carpet run function main:use/summon
execute as @e[name=CombineRoom] at @s if block ~ 15 ~ red_carpet run function main:use/combine
execute as @e[name=TradeRoom] at @s if block ~ 15 ~ yellow_carpet run function main:use/trade
execute as @e[name=CompressRoom] at @s if block ~ 15 ~ orange_carpet run function main:use/compress
execute as @e[name=MineRoom] at @s if block ~ 15 ~ chest run function main:use/mine
execute as @e[name=EndRoom] at @s if block ~ 15 ~ ender_chest run function main:use/store

#Boss handling.
execute as @e[tag=BossRoom] at @s positioned ~ 9 ~ run tag @e[tag=Player,distance=..4] add InBoss
execute if entity @e[tag=Player,tag=InBoss,tag=!InBoss2] run function main:main/boss

execute unless entity @e[tag=Boss] unless score CurrentFloor Math matches 5 if entity @e[tag=Player,tag=InBoss2,tag=!InBoss3] run function enemy:boss/zend

execute if entity @a[tag=Playing,tag=CutScene] run function main:main/cutscene

#Global Timer!
scoreboard players remove SpreadTime Time 1
execute if score SpreadTime Time matches 0 if score Paralyzed ListBuff matches 1.. run tag @a add Move
execute if score SpreadTime Time matches 0 if score Paralyzed ListBuff matches 1.. run scoreboard players set MoveSpeed Math 0
execute if score SpreadTime Time matches 0 if entity @a[tag=Moving,tag=DoneMove,tag=!HitDone,tag=!OtherMove] if score AttackSpeed Math matches ..0 run function path:after
execute if score SpreadTime Time matches 0 unless score Paralyzed ListBuff matches 1.. if entity @e[name=MoveRight,tag=Done_a,tag=!Done_b] run function path:end
execute if score SpreadTime Time matches 0 unless entity @e[name=MoveRight,tag=Done_a,tag=!Done_b] if score MoveSpeed Math matches 1.. if score AttackSpeed Math matches ..0 run function path:after
execute if score SpreadTime Time matches 0 run tag @e[tag=Enemy] remove Hitting
execute if score SpreadTime Time matches 0 run tag @e[tag=Enemy] remove HitDone
execute if score SpreadTime Time matches 0 run tag @e[tag=Friend] remove Hitting
execute if score SpreadTime Time matches 0 run tag @e[tag=Friend] remove HitDone
execute if score SpreadTime Time matches 0 if score MoveSpeed Math matches ..0 if entity @a[tag=Move] run scoreboard players remove AttackSpeed Math 10
execute if score SpreadTime Time matches 0 if score MoveSpeed Math matches ..0 if entity @a[tag=Move] unless entity @e[tag=Boss,scores={EffectParalyze=1..}] run function enemy:boss/amain
execute if score SpreadTime Time matches 0 if score MoveSpeed Math matches ..0 if entity @a[tag=Move] run function main:effect
execute if score SpreadTime Time matches 0 if score MoveSpeed Math matches ..0 if entity @a[tag=Move] run function main:clickenemy
execute if score SpreadTime Time matches 0 if entity @e[tag=TurboMode] unless entity @a[tag=Lobby] run scoreboard players set SpreadTime Time 1
execute if score SpreadTime Time matches 0 run scoreboard players set SpreadTime Time 3

execute unless entity @e[tag=HitStart] run tag @e[tag=Friend,tag=Hitting,tag=!HitDone,limit=1] add HitStart
execute unless entity @e[tag=HitStart] run tag @e[tag=Enemy,tag=Hitting,tag=!HitDone,limit=1] add HitStart
execute as @e[tag=HitStart,tag=Enemy] run function main:countdown
execute as @e[tag=HitStart,tag=Friend] run function main:countdown2