execute at @e[tag=Player] unless entity @e[type=armor_stand,nbt={Small:1b},distance=..2] run scoreboard players set @s TriggerStatue 0

execute if score @s TriggerStatue matches 1 run tellraw @a[tag=Playing] {"text":"\"Not today.\"","italic":"true","color":"gray"}

execute if score @s TriggerStatue matches 2 run scoreboard players set HealthLoss Health 30
execute if score @s TriggerStatue matches 2 run scoreboard players operation HealthLoss Health *= CurrentFloor Math
execute if score @s TriggerStatue matches 2 run scoreboard players operation @e[tag=Player] Health -= HealthLoss Health
execute if score @s TriggerStatue matches 2 at @e[tag=Player] at @e[type=armor_stand,nbt={Small:1b},distance=..2] run particle explosion ~ ~ ~ 0.5 0.5 0.5 0.1 10 force @a[tag=PAR]
execute if score @s TriggerStatue matches 2 at @e[tag=Player] at @e[type=armor_stand,nbt={Small:1b},distance=..2] run fill ~ 8 ~ ~ 9 ~ air destroy
execute if score @s TriggerStatue matches 2 at @e[tag=Player] as @e[type=armor_stand,nbt={Small:1b},distance=..2] run kill @s
execute if score @s TriggerStatue matches 2 run tellraw @a[tag=Playing] {"text":"The statue explodes!","color":"dark_red"}

execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] at @s positioned ~-1 8 ~ run function math:statue/wrath
execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] at @s positioned ~1 8 ~ run function math:statue/wrath
execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] at @s positioned ~ 8 ~1 run function math:statue/wrath
execute if score @s TriggerStatue matches 3 run tag @e[tag=Identified] remove Identified
execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR]
execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ red_concrete
execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 red_concrete
execute if score @s TriggerStatue matches 3 run tellraw @a[tag=Playing] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"Lose Yourself In Anger","color":"red","italic":"true"}]
execute if score @s TriggerStatue matches 3 at @e[tag=Player] as @e[name=WrathStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 4 at @e[tag=Player] as @e[name=GluttonyStatue,distance=..2] at @e[tag=Player] run function math:statue/gluttony
execute if score @s TriggerStatue matches 4 at @e[tag=Player] as @e[name=GluttonyStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR,tag=Eaten]
execute if score @s TriggerStatue matches 4 at @e[tag=Player] as @e[name=GluttonyStatue,distance=..2] at @s run particle smoke ~ ~ ~ 0.6 0.6 0.6 0.1 500 force @a[tag=PAR,tag=!Eaten]
execute if score @s TriggerStatue matches 4 at @e[tag=Player] as @e[name=GluttonyStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ orange_concrete
execute if score @s TriggerStatue matches 4 at @e[tag=Player] as @e[name=GluttonyStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 orange_concrete
execute if score @s TriggerStatue matches 4 run tellraw @a[tag=Playing,tag=Eaten] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"Live To Kill Another Day","color":"gold","italic":"true"}]
execute if score @s TriggerStatue matches 4 run tellraw @a[tag=Playing,tag=!Eaten] ["",{"text":"PRAYER REJECTED\n","color":"dark_gray","bold":"true"},{"text":"Do Not Sacrifice Lives","color":"gold","italic":"true"}]
execute if score @s TriggerStatue matches 4 at @e[tag=Player] as @e[name=GluttonyStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 5 at @e[tag=Player] as @e[name=GreedStatue,distance=..2] at @s run function math:statue/greed
execute if score @s TriggerStatue matches 5 at @e[tag=Player] as @e[name=GreedStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR]
execute if score @s TriggerStatue matches 5 at @e[tag=Player] as @e[name=GreedStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ yellow_concrete
execute if score @s TriggerStatue matches 5 at @e[tag=Player] as @e[name=GreedStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 yellow_concrete
execute if score @s TriggerStatue matches 5 at @e[tag=Player] as @e[name=GreedStatue,distance=..2] run tag @e[tag=Player] add Greedy
execute if score @s TriggerStatue matches 5 run tellraw @a[tag=Playing] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"Your Greed Is Limited","color":"yellow","italic":"true"}]
execute if score @s TriggerStatue matches 5 at @e[tag=Player] as @e[name=GreedStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 6 at @e[tag=Player] as @e[name=EnvyStatue,distance=..2] at @s run scoreboard players remove @e[tag=Player] HealthMax 50
execute if score @s TriggerStatue matches 6 at @e[tag=Player] as @e[name=EnvyStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR]
execute if score @s TriggerStatue matches 6 at @e[tag=Player] as @e[name=EnvyStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ lime_concrete
execute if score @s TriggerStatue matches 6 at @e[tag=Player] as @e[name=EnvyStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 lime_concrete
execute if score @s TriggerStatue matches 6 at @e[tag=Player] as @e[name=EnvyStatue,distance=..2] run tag @e[tag=Player] add Envy
execute if score @s TriggerStatue matches 6 run tellraw @a[tag=Playing] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"May Life Force Have Your Back","color":"green","italic":"true"}]
execute if score @s TriggerStatue matches 6 at @e[tag=Player] as @e[name=EnvyStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 7 at @e[tag=Player] as @e[name=PrideStatue,distance=..2] at @s run function math:statue/pride
execute if score @s TriggerStatue matches 7 at @e[tag=Player] as @e[name=PrideStatue,distance=..2] at @e[tag=Player] run function main:random/orb
execute if score @s TriggerStatue matches 7 at @e[tag=Player] as @e[name=PrideStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR]
execute if score @s TriggerStatue matches 7 at @e[tag=Player] as @e[name=PrideStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ blue_concrete
execute if score @s TriggerStatue matches 7 at @e[tag=Player] as @e[name=PrideStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 blue_concrete
execute if score @s TriggerStatue matches 7 run tellraw @a[tag=Playing] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"Sacrifice To Grow","color":"blue","italic":"true"}]
execute if score @s TriggerStatue matches 7 at @e[tag=Player] as @e[name=PrideStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 8 at @e[tag=Player] as @e[name=DesireStatue,distance=..2] at @e[tag=Player] run function math:statue/desire
execute if score @s TriggerStatue matches 8 at @e[tag=Player] as @e[name=DesireStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR]
execute if score @s TriggerStatue matches 8 at @e[tag=Player] as @e[name=DesireStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ purple_concrete
execute if score @s TriggerStatue matches 8 at @e[tag=Player] as @e[name=DesireStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 purple_concrete
execute if score @s TriggerStatue matches 8 run tellraw @a[tag=Playing] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"Two Blessings and a Curse","color":"dark_purple","italic":"true"}]
execute if score @s TriggerStatue matches 8 at @e[tag=Player] as @e[name=DesireStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 9 at @e[tag=Player] as @e[name=SlothStatue,distance=..2] at @s run particle dragon_breath ~ ~ ~ 0.4 0.4 0.4 0.1 100 force @a[tag=PAR]
execute if score @s TriggerStatue matches 9 at @e[tag=Player] as @e[name=SlothStatue,distance=..2] at @s run fill ~-1 7 ~ ~1 7 ~ pink_concrete
execute if score @s TriggerStatue matches 9 at @e[tag=Player] as @e[name=SlothStatue,distance=..2] at @s run fill ~ 7 ~-1 ~ 7 ~1 pink_concrete
execute if score @s TriggerStatue matches 9 run tellraw @a[tag=Playing] ["",{"text":"PRAYER ACCEPTED\n","color":"dark_gray","bold":"true"},{"text":"Timelines Intertwine At All Times","color":"light_purple","italic":"true"}]
execute if score @s TriggerStatue matches 9 as @e[tag=Player] at @e[tag=BossRoom] run tp @s ~ 8 ~
execute if score @s TriggerStatue matches 9 as @e[tag=Player] at @e[tag=BossRoom] run fill ~-3 10 ~-3 ~3 14 ~3 barrier replace black_concrete
execute if score @s TriggerStatue matches 9 as @e[tag=Player] at @e[tag=BossRoom] run fill ~-3 10 ~-3 ~3 14 ~3 barrier replace black_stained_glass
execute if score @s TriggerStatue matches 9 at @e[tag=Light] run fill ~-3 10 ~-3 ~3 10 ~3 black_stained_glass replace barrier
execute if score @s TriggerStatue matches 9 run tag @e[tag=BossRoom] add Discovered
execute if score @s TriggerStatue matches 9 run tp @e[name=Start,type=armor_stand] @e[tag=Player,limit=1]
execute if score @s TriggerStatue matches 9 at @e[tag=Player] as @e[name=SlothStatue,distance=..2] run kill @s

execute if score @s TriggerStatue matches 3..9 run scoreboard players remove @e[tag=Player] Honor 2
execute unless entity @e[name=LobbySettings,tag=Challenge1] if score @s TriggerStatue matches 2 run scoreboard players add @e[tag=Player] Honor 1
scoreboard players set @s TriggerStatue 0
tag @a[tag=Eaten] remove Eaten
