scoreboard players set Coal Count 0
scoreboard players set Crystal Count 0
scoreboard players set Paper Count 0
scoreboard players set Gold Count 0
scoreboard players set Shard Count 0
scoreboard players set Seeds Count 0
scoreboard players set Wood Count 0

execute positioned ~ 15 ~ run tp @e[type=item,distance=..3,tag=!Pickup,tag=!Teleport] ~ ~0.5 ~
execute positioned ~ 15 ~ as @e[type=item,distance=..3,tag=!Pickup,tag=!Teleport] run data merge entity @s {Motion:[0.0d,0.0d,0.0d]}
execute positioned ~ 15 ~ run tag @e[type=item,distance=..3,tag=!Pickup,tag=!Teleport] add Teleport

execute positioned ~ 15 ~ store result score Coal Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:charcoal"}}] Item.Count
execute positioned ~ 15 ~ store result score Crystal Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:rose_red"}}] Item.Count
execute positioned ~ 15 ~ store result score Paper Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:paper"}}] Item.Count
execute positioned ~ 15 ~ store result score Gold Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:gold_ingot"}}] Item.Count
execute positioned ~ 15 ~ store result score Shard Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:prismarine_shard"}}] Item.Count
execute positioned ~ 15 ~ store result score Seeds Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:cocoa_beans"}}] Item.Count
execute positioned ~ 15 ~ store result score Wood Count run data get entity @e[distance=..2,limit=1,nbt={Item:{id:"minecraft:oak_planks"}}] Item.Count

execute if score Coal Count matches 3.. if score Crystal Count matches 1.. run function main:use/summon/parrot
execute if score Coal Count matches 3.. if score Paper Count matches 1.. run function main:use/summon/sheep
execute if score Coal Count matches 3.. if score Gold Count matches 1.. run function main:use/summon/ocelot
execute if score Coal Count matches 3.. if score Shard Count matches 1.. run function main:use/summon/pig
execute if score Coal Count matches 3.. if score Wood Count matches 1.. run function main:use/summon/cow
execute if score Coal Count matches 3.. if score Seeds Count matches 1.. run function main:use/summon/chicken

execute if score Seeds Count matches 2.. run tag @e[tag=Player] remove CursedWeapon
execute if score Seeds Count matches 2.. run tag @e[tag=Player] remove CursedArmor
execute if score Seeds Count matches 2.. at @e[tag=Player] run particle happy_villager ~ ~ ~ 0.7 0.7 0.7 0.1 100 force
execute if score Seeds Count matches 2.. positioned ~ 15 ~ run kill @e[type=item,nbt={Item:{id:"minecraft:cocoa_beans"}},limit=1,sort=nearest]

summon area_effect_cloud ~ 17 ~ {CustomName:"{\"text\":\"Altar\",\"bold\":\"true\"}",CustomNameVisible:1}
summon area_effect_cloud ~ 16.5 ~ {CustomName:"[{\"text\":\"3 Coal \"},{\"text\":\"+\",\"color\":\"red\"},{\"text\":\" Any \"},{\"text\":\"Item Resource:\",\"color\":\"yellow\"}]",CustomNameVisible:1}
summon area_effect_cloud ~ 16.25 ~ {CustomName:"{\"text\":\"1 Ally\",\"color\":\"green\",\"underlined\":\"true\"}",CustomNameVisible:1}
summon area_effect_cloud ~ 15.75 ~ {CustomName:"[{\"text\":\"2 Seeds:\"}]",CustomNameVisible:1}
summon area_effect_cloud ~ 15.50 ~ {CustomName:"[{\"text\":\"Remove \"},{\"text\":\"Curses\",\"color\":\"red\",\"underlined\":\"true\"}]",CustomNameVisible:1}