#All big rooms

execute as @e[name=Room,tag=RoomBig,limit=10] at @s unless block ~3 7 ~2 air run function xatlantis:room3x
execute as @e[name=Room,tag=RoomBig,limit=10] at @s unless block ~-2 7 ~-3 air run function xatlantis:room3z

#All normal rooms
execute as @e[name=Room,tag=!RoomDone] at @s run function xatlantis:room2

#All bonus rooms
execute as @e[name=Room,tag=RoomSmall,scores={Count=1},tag=!BossRoom,tag=!StartRoom] at @s run function xatlantis:room4

#All giant rooms
execute as @e[name=Room,tag=RoomSmall,scores={Count=4}] at @s unless entity @e[tag=StartRoom,distance=..10] unless entity @e[tag=BossRoom,distance=..10] positioned ~7 ~ ~ if entity @e[distance=..2,name=Room] positioned ~ ~ ~7 if entity @e[distance=..2,name=Room] positioned ~-7 ~ ~ if entity @e[distance=..2,name=Room] run tag @s add Giant
execute as @e[name=Room,tag=Giant,limit=1,sort=random] at @s run function xatlantis:room5

#Start/Boss rooms
execute as @e[name=Room,tag=StartRoom] at @s run function xatlantis:room6a
execute as @e[name=Room,tag=BossRoom] at @s run function xatlantis:room6b

#Extra void placement
execute at @e[name=Room] unless block ~3 7 ~ air run fill ~7 8 ~ ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~-3 7 ~ air run fill ~-7 8 ~ ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~ 7 ~3 air run fill ~ 8 ~7 ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~ 7 ~-3 air run fill ~ 8 ~-7 ~ 9 ~ structure_void replace air

#Wall placement
execute at @e[name=Room,tag=BossRoom] run fill ~5 8 ~5 ~-5 9 ~-5 blue_ice replace air
execute at @e[name=Room,limit=5,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 blue_ice replace air
execute at @e[name=Room,limit=5,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 prismarine_bricks replace air
execute at @e[name=Room,limit=5,sort=random] positioned ~ 7 ~ run fill ~3 ~2 ~3 ~-3 ~2 ~-3 prismarine replace air
execute at @e[name=Room] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 packed_ice replace air
execute at @e[tag=FinalRoom] run fill ~-2 8 ~-2 ~2 9 ~2 structure_void
execute at @e[tag=FinalRoom] run fill ~-2 7 ~-2 ~2 7 ~2 packed_ice
execute at @e[name=Room,tag=BossRoom] unless block ~5 7 ~ packed_ice run fill ~5 8 ~ ~5 9 ~ blue_ice
execute at @e[name=Room,tag=BossRoom] unless block ~-5 7 ~ packed_ice run fill ~-5 8 ~ ~-5 9 ~ blue_ice
execute at @e[name=Room,tag=BossRoom] unless block ~ 7 ~5 packed_ice run fill ~ 8 ~5 ~ 9 ~5 blue_ice
execute at @e[name=Room,tag=BossRoom] unless block ~ 7 ~-5 packed_ice run fill ~ 8 ~-5 ~ 9 ~-5 blue_ice
execute at @e[name=Room,tag=BossRoom] if block ~5 7 ~ packed_ice run setblock ~5 7 ~ red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~-5 7 ~ packed_ice run setblock ~-5 7 ~ red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~5 packed_ice run setblock ~ 7 ~5 red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~-5 packed_ice run setblock ~ 7 ~-5 red_nether_bricks

execute at @e[tag=FinalRoom] if block ~ 7 ~2 red_nether_bricks run fill ~1 8 ~2 ~4 9 ~2 blue_ice
execute at @e[tag=FinalRoom] if block ~ 7 ~2 red_nether_bricks run fill ~-1 8 ~2 ~-4 9 ~2 blue_ice
execute at @e[tag=FinalRoom] if block ~ 7 ~-2 red_nether_bricks run fill ~1 8 ~-2 ~4 9 ~-2 blue_ice
execute at @e[tag=FinalRoom] if block ~ 7 ~-2 red_nether_bricks run fill ~-1 8 ~-2 ~-4 9 ~-2 blue_ice
execute at @e[tag=FinalRoom] if block ~ 7 ~2 red_nether_bricks run clone -25 39 65 -31 41 69 ~-3 7 ~-3
execute at @e[tag=FinalRoom] if block ~ 7 ~-2 red_nether_bricks run clone -25 39 65 -31 41 69 ~-3 7 ~-1

execute at @e[tag=FinalRoom] if block ~2 7 ~ red_nether_bricks run fill ~2 8 ~1 ~2 9 ~4 blue_ice
execute at @e[tag=FinalRoom] if block ~2 7 ~ red_nether_bricks run fill ~2 8 ~-1 ~2 9 ~-4 blue_ice
execute at @e[tag=FinalRoom] if block ~-2 7 ~ red_nether_bricks run fill ~-2 8 ~1 ~-2 9 ~4 blue_ice
execute at @e[tag=FinalRoom] if block ~-2 7 ~ red_nether_bricks run fill ~-2 8 ~-1 ~-2 9 ~-4 blue_ice

execute at @e[tag=FinalRoom] if block ~2 7 ~ red_nether_bricks run function xatlantis:roomfinal2
execute at @e[tag=FinalRoom] if block ~-2 7 ~ red_nether_bricks run function xatlantis:roomfinal1
execute at @e[tag=FinalRoom] if block ~ 7 ~2 red_nether_bricks run function xatlantis:roomfinal3
execute at @e[tag=FinalRoom] if block ~ 7 ~-2 red_nether_bricks run function xatlantis:roomfinal4

execute at @e[tag=FinalRoom] if block ~2 7 ~ red_nether_bricks run clone -25 39 71 -29 41 77 ~-3 7 ~-3
execute at @e[tag=FinalRoom] if block ~-2 7 ~ red_nether_bricks run clone -25 39 71 -29 41 77 ~-1 7 ~-3

#Bonus rooms
execute as @e[name=Room,tag=!StartRoom,tag=!BossRoom,limit=4,sort=random,tag=!FinalRoom] at @s unless block ~ 7 ~ #path:use run function xatlantis:room7