#All big rooms

execute as @e[name=Room,tag=RoomBig,limit=10] at @s unless block ~3 7 ~2 air run function zdungeon:room3x
execute as @e[name=Room,tag=RoomBig,limit=10] at @s unless block ~-2 7 ~-3 air run function zdungeon:room3z

#All normal rooms
execute as @e[name=Room,tag=!RoomDone] at @s run function zdungeon:room2

#All bonus rooms
execute as @e[name=Room,tag=RoomSmall,scores={Count=1},tag=!BossRoom,tag=!StartRoom] at @s run function zdungeon:room4

#All giant rooms
execute as @e[name=Room,tag=RoomSmall,scores={Count=4}] at @s unless entity @e[tag=StartRoom,distance=..10] unless entity @e[tag=BossRoom,distance=..10] positioned ~7 ~ ~ if entity @e[distance=..2,name=Room] positioned ~ ~ ~7 if entity @e[distance=..2,name=Room] positioned ~-7 ~ ~ if entity @e[distance=..2,name=Room] run tag @s add Giant
execute as @e[name=Room,tag=Giant,limit=1,sort=random] at @s run function zdungeon:room5

#Start/Boss rooms
execute as @e[name=Room,tag=StartRoom] at @s run function zdungeon:room6a
execute as @e[name=Room,tag=BossRoom] at @s run function zdungeon:room6b

#Extra void placement
execute at @e[name=Room] unless block ~3 7 ~ air run fill ~7 8 ~ ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~-3 7 ~ air run fill ~-7 8 ~ ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~ 7 ~3 air run fill ~ 8 ~7 ~ 9 ~ structure_void replace air
execute at @e[name=Room] unless block ~ 7 ~-3 air run fill ~ 8 ~-7 ~ 9 ~ structure_void replace air

#Wall placement
execute at @e[name=Room,tag=BossRoom] run fill ~4 8 ~4 ~-4 9 ~-4 iron_block replace air
execute at @e[name=Room,tag=Secret3] run fill ~4 7 ~4 ~-4 9 ~-4 chiseled_stone_bricks replace air
execute at @e[name=Room,limit=6,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 iron_block replace air
execute at @e[name=Room,limit=6,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 smooth_stone replace air
execute at @e[name=Room,limit=6,sort=random] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 cobblestone replace air
execute at @e[name=Room] positioned ~ 7 ~ run fill ~3 ~1 ~3 ~-3 ~2 ~-3 chiseled_stone_bricks replace air
execute at @e[name=Room,tag=BossRoom] unless block ~4 7 ~ chiseled_stone_bricks run fill ~4 8 ~ ~4 9 ~ chiseled_stone_bricks
execute at @e[name=Room,tag=BossRoom] unless block ~-4 7 ~ chiseled_stone_bricks run fill ~-4 8 ~ ~-4 9 ~ chiseled_stone_bricks
execute at @e[name=Room,tag=BossRoom] unless block ~ 7 ~4 chiseled_stone_bricks run fill ~ 8 ~4 ~ 9 ~4 chiseled_stone_bricks
execute at @e[name=Room,tag=BossRoom] unless block ~ 7 ~-4 chiseled_stone_bricks run fill ~ 8 ~-4 ~ 9 ~-4 chiseled_stone_bricks
execute at @e[name=Room,tag=BossRoom] if block ~4 7 ~ chiseled_stone_bricks run setblock ~4 7 ~ red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~-4 7 ~ chiseled_stone_bricks run setblock ~-4 7 ~ red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~4 chiseled_stone_bricks run setblock ~ 7 ~4 red_nether_bricks
execute at @e[name=Room,tag=BossRoom] if block ~ 7 ~-4 chiseled_stone_bricks run setblock ~ 7 ~-4 red_nether_bricks

#Bonus rooms
execute as @e[name=Room,tag=!StartRoom,tag=!BossRoom,limit=4,sort=random] at @s unless block ~ 7 ~ #path:use run function zdungeon:room7
execute at @e[name=Room,tag=Secret5] run clone -20 64 86 -14 67 80 ~-3 7 ~-3

execute at @e[name=Room,tag=Secret3] run summon item ~ 9 ~ {Age:-32768,Item:{id:"music_disc_chirp",Count:1,tag:{HideFlags:63,Void:1s,display:{Lore:['{"text":"§9§l???"}','{"text":"§7This... thing radiates dark energy."}','{"text":"§7Just holding this makes you feel empty inside..."}','{"text":"§7But you still feel like it can be used."}'],Name:"{\"text\":\"Void Opener\",\"color\":\"dark_gray\",\"italic\":\"false\"}"}}}}

execute at @e[name=Room,tag=Secret5] run summon item ~ 9 ~ {Age:-32768,Item:{id:"music_disc_stal",Count:1,tag:{HideFlags:63,Void:2s,display:{Lore:['{"text":"§9§l???"}','{"text":"§7This... thing consists of dark matter."}','{"text":"§7Just holding this makes you lose all hope..."}','{"text":"§7But you still feel like it can be used."}'],Name:"{\"text\":\"Void Crasher\",\"color\":\"dark_gray\",\"italic\":\"false\"}"}}}}

execute at @e[name=Room,tag=Secret7] run summon item ~ 9 ~ {Age:-32768,Item:{id:"music_disc_11",Count:1,tag:{HideFlags:63,Void:3s,display:{Lore:['{"text":"§9§l???"}','{"text":"§7This... thing has a magic aura."}','{"text":"§7Just holding this makes you want to give up..."}','{"text":"§7But you still feel like it can be used."}'],Name:"{\"text\":\"Void Locker\",\"color\":\"dark_gray\",\"italic\":\"false\"}"}}}}

#Craft and Smite room
#Haha, there aren't any! Good luck.